<%
// -------------------------------------------------------------------------------------- 
// version changes
// 1.2.2 - added an edit link at the bottom of the single entry page
// 1.2.1 - improved layout control, allow click on the entry title to see full entry, 
//		show entry count per category, and show only categories with at least 
//		one entry
// -------------------------------------------------------------------------------------- 

var _version = "1.2.2";

function insertEntries(db, skip, validCat, singleId, search, printerFriendly) {
	insertEntriesX(db, skip, validCat, singleId, search, printerFriendly, 0);
}

function dumpEntries(db) {
	insertEntriesX(db, 0, 0, 0, 0, 1, 1);
}

function deleteEntry(id) {
	db.Execute("delete from t_entries where c_id_entry = " + id);
}

function addEntry(title, catid, text) {
	var rec = Server.CreateObject("ADODB.Recordset");
	rec.Open("t_entries", db, 2, 3, 2);
	rec.AddNew();
	var t = title;
	if (t.length < 0) t = "[No Title Given]";
	var e = text;
	if (e.length < 0) e = "[No Text Given]";
	rec("c_title") = t;
	rec("c_content") = e;
	rec("c_id_category") = catid;
	var dt = new Date();
	rec("c_timestamp") = (dt.getMonth() + 1) + "/" + dt.getDate() + "/" + dt.getFullYear() + " " + dt.getHours() + ":" + dt.getMinutes() + ":" + dt.getSeconds();
	rec.Update();
	rec.Close();
	rec = "";
}

function updateEntry(id, title, catid, text) {
	var rec = Server.CreateObject("ADODB.Recordset");
	rec.Open("select * from t_entries where c_id_entry = " + id, db, 2, 3, 1);
	if (!rec.EOF) {
		rec("c_title") = title;
		rec("c_content") = text;
		rec("c_id_category") = catid;
		var dt = new Date();
		rec("c_update") = (dt.getMonth()+1) + "/" + dt.getDate() + "/" + dt.getFullYear() + " " + dt.getHours() + ":" + dt.getMinutes() + ":" + dt.getSeconds();
		rec.Update();
	}
	rec.Close();
	rec = "";
}

function insertIndex(db, validCat, search) {
	// cache the category names
	var id = 0;
	var name = "";
	var catArray = new Array();
	var cats = Server.CreateObject("ADODB.Recordset");
	cats = db.Execute("select c_id_category, c_name from t_categories");
	while (!cats.EOF) {
		id = 0 + parseInt(cats("c_id_category"));
		name = "" + cats("c_name");
		catArray[id] = name;
		cats.MoveNext();
	}
	cats.Close();
	cats = "";

	if (validCat > 0) {
		Response.write("<h2><i>" + catArray[validCat] + "</i> Entries Only</h2>");
	}
	if (search.length > 0) {
		Response.write("<h2>Search Results for <i>&quot;" + search + "&quot;</i> Only</h2>");
	}

	var entries = Server.CreateObject("ADODB.Recordset");
	var sql = "select * from t_entries " + (validCat > 0 ? " where c_id_category = " + validCat : "") + " order by c_title";
	if (search.length > 0) {
		sql = "select * from t_entries where c_title like '%" + search + "%' or c_content like '%" + search + "%' order by c_title";
	}

	Response.Write("<div class=\"entryText\">\n");
	var entryCnt = 0;
	entries = db.Execute(sql);
	while (!entries.EOF) {
		entryCnt++;
		Response.Write("<br>" + entryCnt + ". <a href=\"index.asp?single=" + entries("c_id_entry") + "\">" + entries("c_title") + "</a> " + entries("c_timestamp") + "\n");
		entries.MoveNext();
	}
	Response.Write("</div>\n");

	if (entryCnt < 1) {
		Response.write("<p><i><b>No entries were found.</b></i>");
	}

	entries.Close();
	entries = "";
}

function insertEntriesX(db, skip, validCat, singleId, search, printerFriendly, dump) {
	// cache the category names
	var id = 0;
	var name = "";
	var catArray = new Array();
	var cats = Server.CreateObject("ADODB.Recordset");
	cats = db.Execute("select c_id_category, c_name from t_categories");
	while (!cats.EOF) {
		id = 0 + parseInt(cats("c_id_category"));
		name = "" + cats("c_name");
		catArray[id] = name;
		cats.MoveNext();
	}
	cats.Close();
	cats = "";

	var skipped = 0;
	var entryCnt = 0;
	if (validCat > 0) {
		Response.write("<h2><i>" + catArray[validCat] + "</i> Entries Only</h2>");
	}
	if (search.length > 0) {
		Response.write("<h2>Search Results for <i>&quot;" + search + "&quot;</i> Only</h2>");
	}

	var entries = Server.CreateObject("ADODB.Recordset");
	var sql = "select * from t_entries " + (validCat > 0 ? " where c_id_category = " + validCat : "") + " order by c_timestamp desc";
	// single ID will change all of this
	if (singleId > 0) {
		sql = "select * from t_entries where c_id_entry = " + singleId;
	}
	if (search.length > 0) {
		sql = "select * from t_entries where c_title like '%" + search + "%' or c_content like '%" + search + "%' order by c_timestamp desc";
	}
	var loc = 0;
	var buffer = "";
	var updt = "";
	entries = db.Execute(sql);
	while (!entries.EOF && (entryCnt < _maxEntries || dump > 0)) {
		if (skipped >= skip) {
			entryCnt++;
			id = 0 + parseInt(entries("c_id_category"));
			var temp = "bgcolor=\"" + _sectionColor + "\"";
			Response.write("<p><table width=\"100%\" " + (printerFriendly ? "" : temp) + " border=\"0\"><tr><td>\n");
			//Response.write("<h3 class=\"hdr\"><a class=\"hdr\" href=\"edit.asp?single=" + entries("c_id_entry") + "\">::</a> <a class=\"hdr\" href=\"index.asp?single=" + entries("c_id_entry") + "\">" + entries("c_title") + "</a>" +  (printerFriendly ? "" : " [" + entries("c_id_entry") + "]") + "</h3>");
			Response.write("<h3 class=\"hdr\"><a class=\"hdr\" href=\"edit.asp?single=" + entries("c_id_entry") + "\">::</a> <a class=\"hdr\" href=\"index.asp?single=" + entries("c_id_entry") + "\">" + entries("c_title") + "</a></h3>");
			Response.write("</td></tr></table>\n");
			Response.write("<i class=\"entryTimestamp\">" + entries("c_timestamp") + " - <a href=\"index.asp?cat=" + id + "\">" + catArray[id]  + "</a>");
			updt = "" + entries("c_update");
			if (updt.length > 5) {
				Response.write(" Updated: " + updt);
			}
			Response.write(" (" + entries("c_id_entry") + ")");
			Response.write("</i>\n<p>");
			buffer = "" + entries("c_content");
			loc = buffer.indexOf("[[break");
			Response.Write("<div class=\"entryText\">\n");
			if (loc > 0) {
				var work = buffer.substr(0, loc);
				if (singleId > 0 || printerFriendly > 0) {
					// get rid of the [[break]] in the middle of this
					//work += buffer.substr(loc+9);
					Response.write(stripComments(buffer));
				}
				else {
					var append = "";
					var rest = buffer.substr(loc+7);
					if (rest.substr(0, 1) == "|") {
						// determine if there is something to append before the entry is broken
						var loc2 = rest.indexOf("]]");
						if (loc2 > 0) {
							append = rest.substr(1, loc2-1);
						}
					}

					// provide a link to the rest of things
					Response.write(stripComments(work) + append);
					Response.write("\n<p><a href=\"index.asp?single=" + entries("c_id_entry") + "\">more...</a>\n");
				}
			}
			else {
				Response.write(stripComments(buffer));
			}
			Response.Write("</div>\n");
		}
		else {
			skipped++;
		}
		entries.MoveNext();
	}

	if (entryCnt > 0) {
		//Response.write("<p align=\"center\"><b>" + entryCnt + (entryCnt == 1 ? " entry (" : " entries (") + (skipped+1) + "-" + (skipped+entryCnt) + ") displayed. </b>");

		// put up edit marker
		if (singleId > 0) {
			Response.write("<div class=\"entryText\"><p align=\"right\"><a href=\"edit.asp?single=" + singleId + "\">edit...</a></div>\n");
		}

		Response.write("\n<p><table border=\"0\" width=\"100%\"><tr>");
		Response.write("<td align=\"left\" valign=\"top\" class=\"paging\">");
		if (skip > 0 && !printerFriendly) {
			Response.write("<a href=\"index.asp?skip=" + (skip-_maxEntries < 0 ? 0 : skip-_maxEntries) + "\">&lt;&lt; Previous Entries</a>");
		}
		else {
			Response.write("<font color=\"#cccccc\">Previous Entries</font>");
		}
		Response.write("</td><td class=\"paging\" align=\"center\"<b>" + entryCnt + (entryCnt == 1 ? " entry (" : " entries (") + (skipped+1) + "-" + (skipped+entryCnt) + ") displayed. </b></td>");
		Response.write("<td class=\"paging\" align=\"right\" valign=\"top\">");
		if (entryCnt >= _maxEntries && !printerFriendly && !entries.EOF) {
			Response.write("<a href=\"index.asp?skip=" + (skip+_maxEntries) + "\">Next Entries &gt;&gt;</a>");
		}
		else {
			Response.write("<font color=\"#cccccc\">Next Entries</font>");
		}
		Response.write("</td></tr></table>");
	}
	else {
		Response.write("<p><i><b>No entries were found.</b></i>");
	}

	entries.Close();
	entries = "";
	
	if (dump > 0) {
		var d = new Date();
		Response.write("<p>This dump was performed on " + d.toString() + ".");
	}
}

function addCount(db, key) {
	// this function will add to the count for a given key(name)

	// if one is already there, add to it
	// otherwise, create an entry and then add to it
	var d = new Date();
	var month = d.getMonth() + 1;
	var day = d.getDate();
	var year = d.getFullYear();
	var sql = "select * from t_counts where c_key = '" + key + "' and c_month = " + month + " and c_day = " + day + " and c_year = " + year;
	var rec = Server.CreateObject("ADODB.Recordset");
	rec.Open(sql, db, 2, 3, 1);
	if (rec.EOF) {
		// we need to create an entry
		rec.Close();
		rec.Open("t_counts", db, 2, 3, 2);
		rec.AddNew();
		rec("c_key") = key;
		rec("c_month") = month;
		rec("c_day") = day;
		rec("c_year") = year;
		rec("c_count") = 1;
	}
	else {
		rec("c_count") += 1;
	}
	rec.Update();
	rec.Close();
	rec = "";
}

function dumpRSS(db, number) {
	var entryCnt = 0;
	var entries = Server.CreateObject("ADODB.Recordset");
	var sql = "select * from t_entries order by c_timestamp desc";
	entries = db.Execute(sql);
	var work = "";
	while (!entries.EOF && (entryCnt < number)) {
		entryCnt++;
		Response.write("<item>");
		Response.write("<title>" + entries("c_title") + "</title>");
		Response.write("<link>" + _url + "/?single=" + entries("c_id_entry") + "</link>");
		work = entries("c_content") + "";
		Response.write("<description>" + Server.HTMLEncode(formatForRss(work, 200)) + "</description>");
		Response.write("<pubDate>" + entries("c_timestamp") + "</pubDate>");
		Response.write("</item>");
		entries.MoveNext();
	}

	entries.Close();
	entries = "";
}

function formatForRss(s, max) {
	var append = "";
	var work = s;
	var len = max;
	var loc = work.indexOf("[[rssbeg]]");
	if (loc > 0) {
		var loc2 = work.indexOf("[[rssend", loc);
		if (loc2 > loc) {
			// handle any addition to close up the rssend 
			var rest = work.substr(loc2+8);
			if (rest.substr(0, 1) == "|") {
				var loc3 = rest.indexOf("]]");
				if (loc3 > 0) {
					append = rest.substr(1, loc3-1);
				}
			}

			work = work.substr(loc+10, loc2-loc-10);
			len = 0;	// since they marked it, send everything they marked
		}
	}

	return stripComments(work, len) + append;
}

function stripComments(s, max) {
	var work = s;
	var loc = work.indexOf("[[");
	var loc2 = 0;
	while (loc > 0) {
		loc2 = work.indexOf("]]", loc);
		if (loc2 > loc) {
			work = work.substr(0, loc) + work.substr(loc2+2);
		}
		else {
			// we don't have the end delimiter, so stop
			break;
		}

		loc = work.indexOf("[[");
	}

	// allow them to truncate the returned value
	if (max > 0) return work.substr(0, max);

	return work;
}

function insertFooter() {
	Response.Write('<p>&nbsp;<p><hr size="1" noshade="noshade" />');
	Response.Write('<table border="0" width="100%"><tr><td align="left" valign="top" class="copyright">');
	Response.Write('Questions and comments can be sent to <a href="mailto:' + _emailAddress + '">' + _owner + '</a> or call ' + _owner + ' at ' + _phone + '.');
	Response.Write('</td><td class="copyright" valign="top" align="right"><a href="http://wiserve.com/ezblog"><img src="ezblog.jpg" border="0" width="75" height="30" /></a><br>ezBlog ' + _version + '</td></tr></table>');
	Response.Write('</body></html>');
}

// connect to the database
var db = Server.CreateObject("ADODB.Connection");
	var _dbConnection = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=devlog.mdb";
db.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + _path + "ezblog.mdb";
db.Open();

function closeDB(db) {
	db.Close();
	db = "";
}

%>
